/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-20 19:08:55 UTC)
 * on 2013-06-25 at 00:09:57 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.customsearch.model;

/**
 * Model definition for Context.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the CustomSearch API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Context extends com.google.api.client.json.GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.util.List<Facets>> facets;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * @return value or {@code null} for none
   */
  public java.util.List<java.util.List<Facets>> getFacets() {
    return facets;
  }

  /**
   * @param facets facets or {@code null} for none
   */
  public Context setFacets(java.util.List<java.util.List<Facets>> facets) {
    this.facets = facets;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * @param title title or {@code null} for none
   */
  public Context setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  @Override
  public Context set(String fieldName, Object value) {
    return (Context) super.set(fieldName, value);
  }

  @Override
  public Context clone() {
    return (Context) super.clone();
  }

  /**
   * Model definition for ContextFacets.
   */
  public static final class Facets extends com.google.api.client.json.GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String anchor;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String label;

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getAnchor() {
      return anchor;
    }

    /**
     * @param anchor anchor or {@code null} for none
     */
    public Facets setAnchor(java.lang.String anchor) {
      this.anchor = anchor;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getLabel() {
      return label;
    }

    /**
     * @param label label or {@code null} for none
     */
    public Facets setLabel(java.lang.String label) {
      this.label = label;
      return this;
    }

    @Override
    public Facets set(String fieldName, Object value) {
      return (Facets) super.set(fieldName, value);
    }

    @Override
    public Facets clone() {
      return (Facets) super.clone();
    }

  }

}
